-- Copyright (C) 2008 Papavasileiou Dimitris                             
--                                                                      
-- This program is free software: you can redistribute it and/or modify 
-- it under the terms of the GNU General Public License as published by 
-- the Free Software Foundation, either version 3 of the License, or    
-- (at your option) any later version.                                  
--                                                                      
-- This program is distributed in the hope that it will be useful,      
-- but WITHOUT ANY WARRANTY; without even the implied warranty of       
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
-- GNU General Public License for more details.                         
--                                                                      
-- You should have received a copy of the GNU General Public License    
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.

require "widgets"
require "morewidgets"

widgets.small = widgets.face "Sans-14"
widgets.regular = widgets.face "Sans-20"

graph.fader = frames.timer {
   period = 0,
   timeout = 10,

   tick = function (self, n, delta, elapsed)
	     graph.message.lines[1].opacity = self.timeout - elapsed
	     graph.message.lines[2].opacity = self.timeout - elapsed
		
	     if elapsed >= self.timeout then
		graph.message = nil
		self.parent = nil
	     end
	  end
}

graph.message = widgets.display {
   background = {0.28, 0.24, 0.55},
   size = {1, 1},
   padding = {0.03, 0.03},
   align = {-1, -1},

   lines = widgets.column {
      widgets.small {
	 size = {0.9, 0},
	 align = {-1, 0},
	 text = "If you're wondering where the GUI is, it's web-based!"
      },

      widgets.small {
	 size = {0.9, 0},
	 align = {-1, 0},
	 text = "Visit http://127.0.0.1:29176 with your favorite browser."
      }
   }
}

graph.framerate = options.framerate and widgets.display {
   background = {0.28, 0.24, 0.55},
   size = {1, 1},
   padding = {0.03, 0.03},
   align = {1, 1},

   label = widgets.regular {
      frames.timer {
	 period = 1,

	 link = function ()
		   graphics.oldframes = graphics.frames
		end,

	 tick = function (self, n, delta, elapsed)
		   self.parent.text = string.format ("%.1f",
						     (graphics.frames -
						      graphics.oldframes) /
						     delta)

		   graphics.oldframes = graphics.frames
		end
      }
   }
}
